//+------------------------------------------------------------------+
//|                                                   10points 3.mq4 |
//|                              Copyright  2005, Alejandro Galindo |
//|                                              http://elCactus.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Alejandro Galindo"
#property link      "http://elCactus.com"


extern bool   EcnBroker    = true;
extern bool   UseAutoMagic = true;
extern int    ManualMagic  = 77218;  
extern double TakeProfit = 40;
extern double Lots = 0.01;
extern double InitialStop = 0;
extern double TrailingStop = 20;

extern int MaxTrades=10;
extern int Pips=15;
extern int SecureProfit=10;
extern int AccountProtection=1;
extern int OrderstoProtect=3;
extern int ReverseCondition=0;
extern double EURUSDPipValue=10;
extern double GBPUSDPipValue=10;
extern double USDCHFPipValue=10;
extern double USDJPYPipValue=9.715;
extern int StartYear=2006;
extern int StartMonth=8;
extern int EndYear=3006;
extern int EndMonth=12;
extern int EndHour=22;
extern int EndMinute=30;
extern int mm=0;
extern int risk=12;
extern int AccountisNormal=0;

extern string  Time_Parameters  = "---------- EA Active Time";
extern bool    UseHourTrade     = false;      //False for always trading
extern int     FromHourTrade    = 7;
extern int     ToHourTrade      = 21;

int  OpenOrders=0, cnt=0;
int  slippage=5;
int    digit = 0;
int    Magic;
double sl=0, tp=0;
double BuyPrice=0, SellPrice=0;
double lotsi=0, mylotsi=0;
double _Point;
int mode=0, myOrderType=0;
bool ContinueOpening=True;
double LastPrice=0;
int  PreviousOpenOrders=0;
double Profit=0;
int LastTicket=0, LastType=0;
double LastClosePrice=0, LastLots=0;
double Pivot=0;
double PipValue=0;
string text="", text2="";
string s_symbol;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
   s_symbol = Symbol();
   if (UseAutoMagic) Magic = GetMagic();
               else  Magic = ManualMagic; 
   
   s_symbol = Symbol();
   digit  = MarketInfo(s_symbol,MODE_DIGITS);
   if (digit==2 || digit==4) _Point = 1;
   if (digit==3 || digit==5) _Point = 10;
   if (digit==6)             _Point = 100;
  
   if (UseAutoMagic) Magic = GetMagic();
               else  Magic = ManualMagic;  
                
return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
   if (UseHourTrade)
   {
     if ((Hour()>=FromHourTrade)&&(Hour()<=ToHourTrade))
        Comment("Trading Hours");
     else
     {
        Comment("Non-trading Hours");
     return(0);
     }
   }
   if (AccountisNormal==1)
   {
	  if (mm!=0) { lotsi=MathCeil(AccountBalance()*risk/10000); }
		else { lotsi=Lots; }
   } else {  // then is mini
    if (mm!=0) { lotsi=MathCeil(AccountBalance()*risk/10000)/10; }
		else { lotsi=Lots; }
   }

   if (lotsi>100){ lotsi=100; }
   
   OpenOrders=0;
   for(cnt=0;cnt<OrdersTotal();cnt++)   
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic)
	  {				
	  	  OpenOrders++;
	  }
   }     
   
   if (OpenOrders<1) 
   {
	  if (TimeYear(CurTime())<StartYear) { return(0);  }
	  if (TimeMonth(CurTime())<StartMonth) { return(0); }
	  if (TimeYear(CurTime())>EndYear) { return(0); }
	  if (TimeMonth(CurTime())>EndMonth ) { return(0); }
   }
   
   if (Symbol()=="EURUSD") { PipValue=EURUSDPipValue; }
   if (Symbol()=="GBPUSD") { PipValue=GBPUSDPipValue; }
   if (Symbol()=="USDJPY") { PipValue=USDJPYPipValue; }
   if (Symbol()=="USDCHF") { PipValue=USDCHFPipValue; }
   if (PipValue==0) { PipValue=5; }
   
   if (PreviousOpenOrders>OpenOrders) 
   {	  
	  for(cnt=OrdersTotal();cnt>=0;cnt--)
	  {
	     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  	  mode=OrderType();
		  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
		  {
			if (mode==OP_BUY) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage*Point*_Point,Blue); }
			if (mode==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage*Point*_Point,Red); }
			return(0);
		 }
	  }
   }

   PreviousOpenOrders=OpenOrders;
   if (OpenOrders>=MaxTrades) 
   {
	  ContinueOpening=False;
   } else {
	  ContinueOpening=True;
   }

   if (LastPrice==0) 
   {
	  for(cnt=0;cnt<OrdersTotal();cnt++)
	  {	
	    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
		 mode=OrderType();	
		 if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
		 {
			LastPrice=OrderOpenPrice();
			if (mode==OP_BUY) { myOrderType=2; }
			if (mode==OP_SELL) { myOrderType=1;	}
		 }
	  }
   }

   if (OpenOrders<1) 
   {
	  myOrderType=3;
	  //if (iMACD(14,26,9,MODE_MAIN,0)>0 and iMACD(14,26,9,MODE_MAIN,0)>iMACD(14,26,9,MODE_MAIN,1)) then OrderType=2;
	  if (iMACD(NULL,0,14,26,9,PRICE_CLOSE,MODE_MAIN,0)>iMACD(NULL,0,14,26,9,PRICE_CLOSE,MODE_MAIN,1)) { myOrderType=2; }
	  //if (iMACD(14,26,9,MODE_MAIN,0)<0 and iMACD(14,26,9,MODE_MAIN,0)<iMACD(14,26,9,MODE_MAIN,1)) then OrderType=1;
	  if (iMACD(NULL,0,14,26,9,PRICE_CLOSE,MODE_MAIN,0)<iMACD(NULL,0,14,26,9,PRICE_CLOSE,MODE_MAIN,1)) { myOrderType=1; }
	  if (ReverseCondition==1)
	  {
	  	  if (myOrderType==1) { myOrderType=2; }
		  else { if (myOrderType==2) { myOrderType=1; } }
	  }
   }

   for(cnt=OrdersTotal();cnt>=0;cnt--)
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol() == s_symbol && OrderMagicNumber() == Magic) 
	  {	
	  	  if (OrderType()==OP_SELL) 
	  	  {			
	  	  	  if (TrailingStop>0) 
			  {
				  if (OrderOpenPrice()-Ask>=(TrailingStop+Pips)*Point*_Point)
				  {						
					 if (OrderStopLoss()>(Ask+Point*_Point*TrailingStop))
					 {			
					    OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*_Point*TrailingStop,OrderClosePrice()-TakeProfit*Point*_Point-TrailingStop*Point*_Point,0,Purple);
	  					 return(0);	  					
	  				 }
	  			  }
			  }
	  	  }
   
	  	  if (OrderType()==OP_BUY)
	  	  {
	  		 if (TrailingStop>0) 
	  		 {
			   if (Bid-OrderOpenPrice()>=(TrailingStop+Pips)*Point*_Point) 
				{
					if (OrderStopLoss()<(Bid-Point*_Point*TrailingStop)) 
					{					   
					   OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*_Point*TrailingStop,OrderClosePrice()+TakeProfit*Point*_Point+TrailingStop*Point*_Point,0,Yellow);
                  return(0);
					}
  				}
			 }
	  	  }
   	}
   }
   
   Profit=0;
   LastTicket=0;
   LastType=0;
	LastClosePrice=0;
	LastLots=0;	
	for(cnt=0;cnt<OrdersTotal();cnt++)
	{
	  OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
	  {			
	  	   LastTicket=OrderTicket();
			if (OrderType()==OP_BUY) { LastType=OP_BUY; }
			if (OrderType()==OP_SELL) { LastType=OP_SELL; }
			LastClosePrice=OrderClosePrice();
			LastLots=OrderLots();
			if (LastType==OP_BUY) 
			{
				//Profit=Profit+(Ord(cnt,VAL_CLOSEPRICE)-Ord(cnt,VAL_OPENPRICE))*PipValue*Ord(cnt,VAL_LOTS);				
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit-(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point*_Point; }
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit+(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point*_Point; }
			}
			if (LastType==OP_SELL) 
			{
				//Profit=Profit+(Ord(cnt,VAL_OPENPRICE)-Ord(cnt,VAL_CLOSEPRICE))*PipValue*Ord(cnt,VAL_LOTS);
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit-(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point*_Point; }
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit+(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point*_Point; }
			}
			//Print(Symbol,":",Profit,",",LastLots);
	  }
   }
	
	Profit=Profit*PipValue;
	text2="Profit: $"+DoubleToStr(Profit,2)+" +/-";
   if (OpenOrders>=(MaxTrades-OrderstoProtect) && AccountProtection==1) 
   {	    
	     //Print(Symbol,":",Profit);
	     if (Profit>=SecureProfit) 
	     {
	        OrderClose(LastTicket,LastLots,LastClosePrice,slippage,Yellow);		 
	        ContinueOpening=False;
	        return(0);
	     }
   }

      if (!IsTesting()) 
      {
	     if (myOrderType==3) { text="No conditions to open trades"; }
	     else { text="                         "; }
	     Comment("LastPrice=",LastPrice," Previous open orders=",PreviousOpenOrders,"\nContinue opening=",ContinueOpening," OrderType=",myOrderType,"\n",text2,"\nLots=",lotsi,"\n",text);
      }

      if (myOrderType==1 && ContinueOpening) 
      {	
	     if ((Bid-LastPrice)>=Pips*Point*_Point || OpenOrders<1) 
	     {		
		    SellPrice=Bid;				
		    LastPrice=0;
		    if (TakeProfit==0) { tp=0; }
		    else { tp=SellPrice-TakeProfit*Point*_Point; }	
		    if (InitialStop==0) { sl=0; }
		    else { sl=SellPrice+InitialStop*Point*_Point;  }
		    if (OpenOrders!=0) 
		    {
			      mylotsi=lotsi;			
			      for(cnt=1;cnt<=OpenOrders;cnt++)
			      {
				     if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi*1.5,2); }
				     else { mylotsi=NormalizeDouble(mylotsi*2,2); }
			      }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    if (!EcnBroker)
   		       OrderSend(s_symbol,OP_SELL,mylotsi,SellPrice,slippage*Point*_Point,sl,tp,"10 pt 3",Magic,0,Red);		    		    
          else
          {
                int sellTicket = OrderSend(s_symbol,OP_SELL,mylotsi,SellPrice,slippage*Point*_Point,0,0,"10 pt 3",Magic,0,Red);		    		    
                if (sellTicket >= 0)
                  OrderModify(sellTicket,OrderOpenPrice(),sl,tp,0,CLR_NONE);
          }		       	    		    
		    return(0);
	     }
      }
      
      if (myOrderType==2 && ContinueOpening) 
      {
	     if ((LastPrice-Ask)>=Pips*Point*_Point || OpenOrders<1) 
	     {		
		    BuyPrice=Ask;
		    LastPrice=0;
		    if (TakeProfit==0) { tp=0; }
		    else { tp=BuyPrice+TakeProfit*Point*_Point; }	
		    if (InitialStop==0)  { sl=0; }
		    else { sl=BuyPrice-InitialStop*Point*_Point; }
		    if (OpenOrders!=0) {
			   mylotsi=lotsi;			
			   for(cnt=1;cnt<=OpenOrders;cnt++)
			   {
				  if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi*1.5,2); }
				  else { mylotsi=NormalizeDouble(mylotsi*2,2); }
			   }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    if (!EcnBroker)
   		       OrderSend(s_symbol,OP_BUY,mylotsi,BuyPrice,slippage*Point*_Point,sl,tp,"10 pt 3",Magic,0,Blue);		    
          else
          {
                int buyTicket = OrderSend(s_symbol,OP_BUY,mylotsi,BuyPrice,slippage*Point*_Point,0,0,"10 pt 3",Magic,0,Blue);
                if (buyTicket >= 0)
                  OrderModify(buyTicket,OrderOpenPrice(),sl,tp,0,CLR_NONE);
          }		       	    
		    return(0);
	     }
      }   

//----
   return(0);
  }
//+------------------------------------------------------------------+
//
//
//
//
//

int GetMagic() 
{

   if (StringFind(s_symbol,"CADJPY") >= 0) return(11921);
   if (StringFind(s_symbol,"CADCHF") >= 0) return(12922);
   
   if (StringFind(s_symbol,"GOLD")   >= 0) return(13931);
   if (StringFind(s_symbol,"SILVER") >= 0) return(14932);
   
   if (StringFind(s_symbol,"NZDJPY") >= 0) return(15941);
   if (StringFind(s_symbol,"NZDUSD") >= 0) return(16942);
   
   if (StringFind(s_symbol,"CHFJPY") >= 0) return(17951);
   
   if (StringFind(s_symbol,"EURAUD") >= 0) return(18961);
   if (StringFind(s_symbol,"EURCAD") >= 0) return(19971);
   if (StringFind(s_symbol,"EURUSD") >= 0) return(20963);
   if (StringFind(s_symbol,"EURGBP") >= 0) return(21964);
   if (StringFind(s_symbol,"EURCHF") >= 0) return(22965);
   if (StringFind(s_symbol,"EURNZD") >= 0) return(23966);
   if (StringFind(s_symbol,"EURJPY") >= 0) return(24967);
   
   if (StringFind(s_symbol,"GBPUSD") >= 0) return(25971);
   if (StringFind(s_symbol,"GBPCHF") >= 0) return(26972);
   if (StringFind(s_symbol,"GBPJPY") >= 0) return(27973);
   
   if (StringFind(s_symbol,"USDCHF") >= 0) return(28981);
   if (StringFind(s_symbol,"USDJPY") >= 0) return(29982);
   if (StringFind(s_symbol,"USDCAD") >= 0) return(30983);

   if (StringFind(s_symbol,"AUDUSD") >= 0) return(31991);
   if (StringFind(s_symbol,"AUDNZD") >= 0) return(32992);
   if (StringFind(s_symbol,"AUDCAD") >= 0) return(33993);
   if (StringFind(s_symbol,"AUDCHF") >= 0) return(34994);
   if (StringFind(s_symbol,"AUDJPY") >= 0) return(35995);
   
return(ManualMagic);
}


